; Micro socks4 server
; (C) SLESH 2010
;
format PE GUI

entry _start
include 'win32ax.inc'
;  
;  Socks4 
struct S4REQUEST
       version db ? ; 
       command db ? ; 
       port dw ? ; 
       addr dd ? ; 
       userid  db 1024 dup (?) ;       
ends

;   FD_SET 
struct DOUBLE_FD_SET
       fd_count dd ?
       fd_1 dd ?
       fd_2 dd ?
ends

;   select
struct TIMEVAL
       tv_sec dd ?
       tv_usec dd ?
ends

;  ,   
section '.code' code writeable readable executable import
;----------- 
library kernel32, 'KERNEL32.DLL',\
	user32, 'USER32.DLL',\
	wsock32, 'ws2_32.dll'


include 'apia\kernel32.inc'
include 'apia\user32.inc'
include 'apia\wsock32.inc'

;----------  
;     
proc PortMapper, client_sock, server_sock
 locals
	fds_read DOUBLE_FD_SET ? ;  select
	tv TIMEVAL ? ;   select
	buf db 4096 dup (?) ;    
 endl

 mov [tv.tv_usec], 0
 mov [tv.tv_sec], 2 ; 2  

pm_loop: ;    
 mov eax, [client_sock] ;   
 mov [fds_read.fd_1], eax
 mov eax, [server_sock] ;   
 mov [fds_read.fd_2], eax
 mov [fds_read.fd_count], 2 ;     2 
 invoke select, 0, addr fds_read, 0, 0, addr tv ;   
 cmp eax, 0
 jng pm_loop ;      

 invoke __WSAFDIsSet, [client_sock], addr fds_read  ;   
 test eax, eax
 jz pm_m1 ;      
 invoke recv, [client_sock], addr buf, 4096, 0 ;  
 cmp eax, 0
 jng pm_end ;    ,     
 invoke send, [server_sock], addr buf, eax, 0 ;     

pm_m1:
 invoke __WSAFDIsSet, [server_sock], addr fds_read ;   
 test eax, eax
 jz pm_loop ;   ,    
 invoke recv, [server_sock], addr buf, 4096, 0	;    
 cmp eax, 0
 jng pm_end ;    ,     
 invoke send, [client_sock], addr buf, eax, 0 ;     

 jmp pm_loop ;   

pm_end:
 ret
endp

;    
proc ClientRoute, client_sock
 locals
	request S4REQUEST ? ;  Socks4 /
	caddr sockaddr_in ? ;    
	ssock dd -1 ;  
	portmap dd 0 ;     
 endl

 invoke recv, [client_sock], addr request, sizeof.S4REQUEST, 0 ;  
 cmp eax, 8 ;         
 jl _cr_end ; /
 cmp [request.command], 1 ;   connect
 mov [request.command], 91 ;    
 jne _cr_send ;    connect    
 invoke socket, AF_INET, SOCK_STREAM, 0 ;      
 cmp eax, -1 ;\
 je _cr_send ;   
 mov [ssock], eax ;   
 mov [caddr.sin_family], AF_INET ;    
 mov eax, [request.addr]
 mov [caddr.sin_addr], eax ; 
 mov ax, [request.port]
 mov [caddr.sin_port], ax ; 
 mov [request.version], 0
 invoke connect, [ssock], addr caddr, sizeof.sockaddr_in ;   
 test eax, eax ;    
 jnz _cr_send  ; /
 mov [request.command], 90 ;      
 inc [portmap] ;      
_cr_send:
 invoke send, [client_sock], addr request, 8, 0 ;     
 cmp [portmap], 0 ;      (..  )
 jz _cr_end	  ; /
 stdcall PortMapper, [client_sock], [ssock] ;  

_cr_end:
 cmp [ssock], -1 ;        
 je _cr_end1	 ; /
 invoke closesocket, [ssock] ;   
_cr_end1:
 invoke closesocket, [client_sock] ;   
 ret
endp

;    
_start:
 invoke WSAStartup, 202h, wsadata ;  winsock'a
 invoke socket, AF_INET, SOCK_STREAM, 0 ;    
 cmp eax, -1  ;  
 je _exit     ; /
 mov [ssock], eax  ;  
 invoke bind, [ssock], saddrs, sizeof.sockaddr_in  ;   
 test eax, eax	;    
 jnz _exit	; /
 invoke listen, [ssock], 10  ;     
 test eax, eax	;  
 jnz _exit	; /
m1:  ;    
 invoke accept, [ssock], 0, 0  ;  
 cmp eax, -1  ;      
 je m1	      ; /
 mov [csock], eax ;  
 invoke CreateThread, 0, 10000h, ClientRoute, eax, 0, tmp  ;   
 test eax, eax
 jz m2;    
 invoke CloseHandle, eax ;      
 jmp m1 ;  
m2: ;    
 invoke closesocket, [csock] ;  
 jmp m1 ;  
_exit:
 invoke ExitProcess,0
;--------  --------------
 saddrs sockaddr_in AF_INET, 380Ch, 0;     bind. PORT 3128
 ssock dd ? ;   
 csock dd ? ;   
 tmp dd ? ;     
 wsadata WSADATA ? ;   winsock
